package main

import "fmt"

// constants are declared as variables, but using the keyword const
const Pi = 3.14

func main() {

	// multiple variables declaration with default init (0, false, "")
	// types follow variable names
	var x, y, z int
	println(x, y, z)

	// multiple assignments are possible
	// semi-colons ; are not necessary, use new-line instead
	x = 1
	x, y, z = 2, x+1, y+1
	println(x, y, z)

	// multiple variables declaration with init
	var i, j int = 1, 2
	println(i, j)

	// multiple intializations
	// using := the keyword var can be omitted (:= within function body only)
	// types are inferred
	n, f, s, b, c := 5, 2.5, "Hello", true, 1+2i
	fmt.Printf("%v (%T)\n", n, n)
	fmt.Printf("%v (%T)\n", f, f)
	fmt.Printf("%v (%T)\n", s, s)
	fmt.Printf("%v (%T)\n", b, b)
	fmt.Printf("%v (%T)\n", c, c)
	fmt.Printf("Pi is %v (%T)\n", Pi, Pi)

	// Go base types:
	// bool string
	// int  int8  int16  int32  int64
	// uint uint8 uint16 uint32 uint64 uintptr
	// byte (alias for uint8)
	// rune (alias for int32 - "code point" Unicode)
	// float32 float64
	// complex64 complex128

	// cast: T(v)
	n = int(f)
	f = float64(n)
}
