package main

import "fmt"

// public names (exported) begin with a capital letter
func Square(a int) int {
	return a*a
}

// functions can return tuples
func Swap(a int, b int) (int, int) {
	return b, a
}

// return values can be given a name
func Split(x, y int) (d, r int) {
	d = x / y
	r = x % y
	return // naked return
}

func Max(x, y int) int {
	// if syntax
	// no (), but {} are mandatory, else {} is optional
	if x > y {
		return x
	} else {
		return y
	}
}

func main() {
	println(Square(3))
	println(Swap(4, 2))
	println(Split(17, 3))
	println(Max(5,3))

	// functions are values too
	twice := func(x int) int { return 2 * x }
	fmt.Printf("twice has type %T\n", twice)
	
	apply := func(f func(int) int, x int) int { return f(x) }
	fmt.Printf("apply has type %T\n", apply)
	
	fmt.Println("apply(twice, 3) =",apply(twice,3))

}


