package main

import "fmt"

type Vertex struct {
	X int
	Y int
}

func main() {
	// create a Vertex
	v := Vertex{1, 2}
	fmt.Printf("v is %v (%T)\n", v, v)

	// access a field using dot notation
	v.X = v.Y * 2
	fmt.Println("v is", v)

	q := v // copy
	fmt.Printf("q is %v (%T)\n", q, q)
	q.X = 1e5
	fmt.Println("q is", q)
	fmt.Println("v is still", v) // v is unchanged

	p := &v // alias
	fmt.Printf("p is %v (%T)\n", p, p)
	p.X = 1e5 // p.X same as (*p).X
	fmt.Printf("v is %v (%T)\n", v, v)

	// field assignment
	v1 := Vertex{1, 2} // has type Vertex
	v2 := Vertex{Y: 1} // X:0 is implicit
	v3 := Vertex{}     // X:0 and Y:0
	fmt.Println(v1, v2, v3)
}


