package main


func main() {
	c := make(chan int) // create a channel for sending integers
	c <- 245 // send 245 (but sending is blocking!)
	n := <-c // receive from c and store the value in n
	println(n)
}

func main1() {
	c := make(chan int,1) // create a buffered channel for sending integers
	c <- 245 // send 245 (now sending is not blocking!)
	n := <-c // receive from c and store the value in n
	println(n)
}

func main2() {
	c := make(chan int)
	// do the sending in an anonymous goroutine
	go func() {
		c <- 245
	}()
	n := <-c
	println(n)
}

func main3() {
	c := make(chan int)
	go func() {
		c <- 245
	}()
	// avoid to use variable n
	println(<-c)
}

